/*
====================================================================================================

    Copyright (C) 2020 RRe36

    All Rights Reserved unless otherwise explicitly stated.


    By downloading this you have agreed to the license and terms of use.
    These can be found inside the included license-file
    or here: https://rre36.github.io/license/

    Violating these terms may be penalized with actions according to the Digital Millennium
    Copyright Act (DMCA), the Information Society Directive and/or similar laws
    depending on your country.

====================================================================================================
*/

/* ------ atmosphere settings ------ */

    /* --- clouds --- */
    #define cloudVolumeEnabled
    #define cloudVolumeSkylightDither
    #define cloudSourceRes 1    //[0 1 2]
    #define cloudCirrusEnabled

    /* --- fog --- */
    #define fogVolumeEnabled
    //#define fogMistAdvanced

/* ------ lighting settings ------ */
#define lightmapSmoothingEnabled
#define lightHqFilterEnabled
#define directionalLMEnabled
//#define shadowFilterHQ
#define contactShadowsEnabled
#define subsurfaceScatteringEnabled
#define specularBRDFEnabled
#define minLightLuma 0.1   //[0.1 0.2 0.3 0.4 0.5 0.75 1.0 1.25 1.5 1.75 2.0 2.5 3.0 3.5 4.0 5.0 6.0 7.0 8.0 9.0 10.0]
#define emitterBoostEnabled
#define emitterRecoloring 0.5  //[0.0 0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1.0]

    /* ------ effects settings ------ */
    #define ambientOcclusionEnabled


/* ------ world settings ------ */
#define normalmapEnabled
#define normalmapFormat 0   //[0 1]
#define windEffectsEnabled
#define windIntensity 1.0  //[0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1.0 1.1 1.1 1.2 1.3 1.4 1.5 1.6 1.7 1.8 1.9 2.0]


/* ------ post processing settings ------ */
#define taaEnabled
#define imageSharpenEnabled
#define bloomEnabled
//#define newExposure
//#define ACES_RRT

    /* ------ exposure settings ------ */
    #define exposureMinlum 1.0     //[0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1.0 1.2 1.4 1.6 1.8 2.0 2.2. 2.4 2.6 2.8 3.0 3.5 4.0 5.0 6.0 8.0 10.0 15.0 20.0]
    #define exposureSpeed 1.0      //[0.2 0.4 0.6 0.8 1.0 1.2 1.4 1.6 1.8 2.0 2.5 3.0 4.0]
    //#define manualExposureEnabled
    #define manualExposureValue 5.0     //[0.1 0.3 0.5 1.0 1.5 2.0 3.0 4.0 5.0 6.0 7.0 8.0 9.0 10.0 12.0 14.0 16.0 18.0 20.0 25.0 30.0 40.0 50.0]


/* ------ internals ------ */
#define SKY_RENDER_LOD 3

#if cloudSourceRes == 0
    #define CLOUD_RENDER_LOD 6.0
#elif cloudSourceRes == 1
    #define CLOUD_RENDER_LOD 5.0
#elif cloudSourceRes == 2
    #define CLOUD_RENDER_LOD 4.0
#endif


#define DEBUG_VIEW 0    //[0 1 2 3 4] 0-off, 1-whiteworld, 2-ao

//#define deffNAN
//#define compNAN